#include"grid.h"
//#include<cassert>
grid::grid()
{   int i,j;
    for(i=0;i<9;i++)
    {   for(j=0;j<9;j++)
        {   grille[i][j]=Case();
        }
    }
    
    for(i=0;i<81;i++)
    {   choix[i/9][i%9]=9;
    }
    choix_init_flag=false;
    choix_set_flag=false;
    lastmodif=80;
}

grid::~grid()
{   
}

//cherche si une valeur est prsente dans le carre correspondant a une case, renvoie true si vrai
bool grid::in_square(int valeur,int ligne,int colonne) const
{   //cout<<"in_square"<<endl;

    int i,j;
    for(i=3*(ligne/3);i<3*(ligne/3)+3;i++)
    {   for(j=3*(colonne/3);j<3*(colonne/3)+3;j++)
        {   //assert((i<9)&&(j<9)&&(i>=0)&&(j>=0));
            if (grille[i][j].valeur==valeur)
            {   return true;
            }
        }
    }
    return false;
}
//cherche si une valeur est prsente sur la ligne correspondant a une case,ne cherche pas dans le carr
bool grid::in_line(int valeur,int ligne) const
{   //cout<<"in_line"<<endl;

    int i;
     for(i=0;i<9;i++)
        {  
            if (grille[ligne][i].valeur==valeur)
            {   
                return true;
            }
        }
       
        return false;
}   


//cherche si une valeur est prsente sur la colonne correspondant a une case,ne cherche pas dans le carr
bool grid::in_colonne(int valeur,int colonne) const
{   //cout<<"in_colonne"<<endl;

        int i;
     for(i=0;i<9;i++)
        {  
            if(grille[i][colonne].valeur==valeur)
            {   return true;
            }
        }
        return false;
}


//determine si on peut placer un chiffre donne dans une case donnee 
bool grid::libre(int valeur,int ligne,int colonne) const
{   //cout<<"libre"<<endl;
    
    bool b;
    b = (!( in_colonne(valeur,colonne) ||in_line(valeur,ligne) || in_square(valeur,ligne,colonne) ) );
    return b;
    
}

//revoie le nombre de choix possibles pour une case donnee
int grid::choice(int ligne,int colonne) const
{  //cout<<"choix"<<endl;
    int choix=0,i;
    for(i=1;i<=9;i++)
    {   if (libre(i,ligne,colonne))
        {   choix++;
        }
    }
    return choix;
}

//revoie le numero de la case ayant le moins de choix possibles
int grid::leastchoice()
{   int pos=0,_choix=10,i;
    if(!choix_init_flag)
    {   leastchoiceinit();
    }   
    else if(!choix_set_flag)
    {  setchoice();
    }
    for(i=0;i<81;i++)
    {   if((choix[i/9][i%9]<_choix)&&(!grille[i/9][i%9].fixed_flag))
        {   _choix=choix[i/9][i%9];
            pos=i;
        }
    }
    return pos;
}

//initialise la grille des choix possibles
void grid::leastchoiceinit()
{   int i;
    for(i=0;i<81;i++)
    {   choix[i/9][i%9]=choice(i/9,i%9);
    }
    choix_init_flag=true;
    choix_set_flag=true;
}

//met a jour la grille des choix possibles apres la modification d'une case
void grid::setchoice()
{   int i,j; 
    for(i=0;i<9;i++)
        {   choix[i][lastmodif%9]=choice(i,lastmodif%9);
            choix[lastmodif/9][i]=choice(lastmodif/9,i);
        }
        for(i=3*(lastmodif/27);i<3*(lastmodif/27)+3;i++)
        {   for(j=3*((lastmodif%9)/3);j<3*((lastmodif%9)/3)+3;j++)
            {   //assert((i<9)&&(j<9)&&(i>=0)&&(j>=0));
                choix[i][j]=choice(i,j);
            }
        }
        choix_set_flag=true;
}

//affiche la grille vers le flux de sortie (par defaut cout)
void grid::show(ostream &o) const
{   int i,j;
    o<<"+---+---+---+---+---+---+---+---+---+\n";
    for(i=0;i<9;i++)
    {   cout<<"| ";
        for(j=0;j<9;j++)
    {   o<<grille[i][j].valeur<<" | ";
        }
       o<<"\n+---+---+---+---+---+---+---+---+---+\n";
    }
}

//renvoie la case aux coordonnes specifiees
Case *grid::Grille(int ligne,int colonne)
{   return &grille[ligne][colonne];
}

//modifie le drapeau indiquant si une case est fixee ou non
void grid::setflag(bool b,int ligne,int colonne)
{   grille[ligne][colonne].fixed_flag=b;
    choix_set_flag=false;
}
//modifie la valeur de la case
void grid::setvaleur(int valeur,int ligne,int colonne)
{   grille[ligne][colonne].valeur=valeur;
    lastmodif=9*ligne+colonne;
    choix_set_flag=false;
}