#include"grid.h"
#include<vector>
#include<time.h>
#include<iostream>
#include<stdlib.h>
#include<fstream>


//cette fonction recursive explore l'ensemble des solutions possibles, en partant a chaque fois de la case non-renseignee ayant le moins de choix disponibles, les solutions satisfaisantes sont stockees dans le vector "solutions", la fonction ne s'arrete qu'apres avoir parcouru tout l'arbre et stocke toutes les solutions
void explore(int ligne,int colonne,int profondeur,grid &g,int & nbsol,int &nbbranches,vector<grid> &solutions)
{   
    int i,tmp=0;
        if (profondeur==81)
    {   nbsol++;
        solutions.push_back(g);
        cout<<nbsol<<endl;
    }
    else if(g.Grille(ligne,colonne)->fixed_flag)
    {   cout<<"pas de solution"<<endl;
    }
    else
    {   g.setflag(true,ligne,colonne);
        for (i=1;i<10;i++)
        {   nbbranches++;
            if (g.libre(i,ligne,colonne))
            {   g.setvaleur(i,ligne,colonne);
                tmp=g.leastchoice();
                explore(tmp/9,tmp%9,profondeur+1,g,nbsol,nbbranches,solutions);
            }
        }
        g.setflag(false,ligne,colonne);
       g.setvaleur(0,ligne,colonne);
       g.setchoice();
    }
}
//le programme lit la grille depuis le arguments de la ligne de commande uniquement, 0 pour une valeur non-renseignee, 1-9 sinon, toute autre valeur risque de planter le programme
int main (int argc,char* argv[])
{   int i,j;
    int tmp;
    int profondeur=0;//sert a determiner le nombre de cases deja renseignees, utilise ensuite comme condition d'arret de la fonction explorer
    float temps_cpu;
    int nbsol=0;
    int nbbranches=0;
    ifstream IN;
    clock_t temps_initial, temps_final;
    grid g;
    vector<grid> solutions;
    
    if((argc>=3)&&(argv[1][0]=='f'))
    {   ;
        IN.open(argv[2]);
        for (i=0;i<9;i++)
        {   for(j=0;j<9;j++)
            {   IN>>tmp;
                if (tmp!=0)
                {   if (g.libre(tmp,i,j) )
                    {   
                        g.setflag(true,i,j);
                        g.setvaleur(tmp,i,j);
                        profondeur++;
                    }
                    else
                    {   cout<<"grille insoluble, erreur d'enonce"<<endl;
                        return 0;
                    }
                }
                
            }
        
        }
        IN.close();
    }
    else if (argc<82)
    {   cout<<"erreur grille incomplete"<<endl;
       return (0);
    }
    else
    //initialisation
    for (i=0;i<9;i++)
    {   for(j=0;j<9;j++)
        {   tmp=atoi(argv[9*i+j+1]);
            if (tmp!=0)
            {   if (g.libre(tmp,i,j) )
                {   
                    g.setflag(true,i,j);
                    g.setvaleur(tmp,i,j);
                    profondeur++;
                }
                else
                {   cout<<"grille insoluble, erreur d'enonce"<<endl;
                    return 0;
                }
                
            }
           
        }
        
    }
    
    temps_initial = clock ();
    tmp=g.leastchoice();
    explore(tmp/9,tmp%9,profondeur,g,nbsol,nbbranches,solutions);
    temps_final = clock ();
    temps_cpu = (temps_final - temps_initial) /(float) CLOCKS_PER_SEC;

    
    //affichage des statistiques de l'execution du programme: temps d'exectution
    cout<<"calcul effectue en "<<temps_cpu<<" secondes"<<endl;
    
    // nombre de branches parcourues
    cout<<nbbranches<<" branches parcourues"<<endl;
    // nombre de solutions trouvees
    cout<<nbsol<<" solution(s) trouvee(s)"<<endl;
    // lesdites solutions
    for(i=0;i<nbsol;i++)
    {   cout<<"solution numero "<<i+1<<endl;
        solutions[i].show();
    }
   solutions.clear();
    return (nbsol);
}
